#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
#include <functional>

using namespace std;

long long zbir_kvadrata(int a, int b) {
  return (long long)a * a + (long long)b * b;
}

int main() {
  int n;
  cin >> n;
  int k;
  cin >> k;

  // sve uredjene trojke stavljamo u niz
  vector<tuple<long long, int, int>> v;
  for (int b = 0; b <= n; b++)
    for (int a = 0; a <= b; a++)
      v.emplace_back(zbir_kvadrata(a, b), a, b);

  // sortiramo niz - trojke se porede leksikografski, prvo po prvoj
  // komponenti (zbiru kubova), a ako je zbir kubova jednak, onda po
  // prvom sabirku
  sort(begin(v), end(v));

  // ispisujemo element na poziciji k
  int a, b;
  long long s;
  tie(s, a, b) = v[k];
  cout << a << " " << b << " " << s << endl;
  
  return 0;
}
