#include <iostream>
#include <tuple>
#include <queue>
#include <functional>

using namespace std;

long long zbir_kvadrata(int a, int b) {
  return (long long)a * a + (long long)b * b;
}

int main() {
  int n;
  cin >> n;
  int k;
  cin >> k;

  // red neopadajuce sortiran na osnovu vrednosti zbira kvadrata (prve
  // komponente uredjene trojke), a zatim na osnovu manjeg sabirka
  // (druge komponente uredjene trojke)
  priority_queue<tuple<long long, int, int>,
                 vector<tuple<long long, int, int>>,
                 greater<tuple<long long, int, int>>> pq;

  // ubacujemo pocetni element svake liste u red sa prioritetom
  for (int b = 0; b <= n; b++)
    pq.emplace(zbir_kvadrata(0, b), 0, b);
  
  // odredjujemo element objedinjene liste na poziciji k
  for (int i = 0; i < k; i++) {
    // skidamo element sa pocetka reda
    int a, b;
    long long s;
    tie(s, a, b) = pq.top();
    pq.pop();
    
    // dodajemo u red naredni element liste u kojoj se nalazi skinuti element
    if (a < b)
      pq.emplace(zbir_kvadrata(a + 1, b), a+1, b);
  }

  // element objedinjene liste na poziciji k je onaj koji je trenutno
  // na pocetku reda
  int a, b;
  long long s;
  tie(s, a, b) = pq.top();
  cout << a << " " << b << " " << s << endl;
  
  return 0;
}
